<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SR_DevolucionCabecera.xml */
/* Generado: 2021-06-25 10:06:37 */

/* Mantenimiento de los registros de la tabla SR_DevolucionCabecera */
abstract class BaseSR_DevolucionCabeceraDP extends SR_DevolucionCabeceraBV
{
    /* Constructor ( Establece los valores desde un objeto SR_DevolucionCabeceraBN ) */
    public function __construct( SR_DevolucionCabeceraBN $o_SR_DevolucionCabeceraBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SR_DevolucionCabeceraBN ) )
        {
            $this->setByBN( $o_SR_DevolucionCabeceraBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SR_DevolucionCabeceraBN */
    public function setByBN( SR_DevolucionCabeceraBN $o_SR_DevolucionCabeceraBN )
    {
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getDevolucionCabId() ) )
        {
            $this->setDevolucionCabId( $o_SR_DevolucionCabeceraBN->getDevolucionCabId() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_SR_DevolucionCabeceraBN->getIdCompania() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_SR_DevolucionCabeceraBN->getIdSucursal() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getIdProyecto() ) )
        {
            $this->setIdProyecto( $o_SR_DevolucionCabeceraBN->getIdProyecto() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getOrdenId() ) )
        {
            $this->setOrdenId( $o_SR_DevolucionCabeceraBN->getOrdenId() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getParentId() ) )
        {
            $this->setParentId( $o_SR_DevolucionCabeceraBN->getParentId() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getTipo() ) )
        {
            $this->setTipo( $o_SR_DevolucionCabeceraBN->getTipo() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getTransGuiaSerie() ) )
        {
            $this->setTransGuiaSerie( $o_SR_DevolucionCabeceraBN->getTransGuiaSerie() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getTransGuiaNumero() ) )
        {
            $this->setTransGuiaNumero( $o_SR_DevolucionCabeceraBN->getTransGuiaNumero() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getObraGuiaSerie() ) )
        {
            $this->setObraGuiaSerie( $o_SR_DevolucionCabeceraBN->getObraGuiaSerie() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getObraGuiaNumero() ) )
        {
            $this->setObraGuiaNumero( $o_SR_DevolucionCabeceraBN->getObraGuiaNumero() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getObservaciones() ) )
        {
            $this->setObservaciones( $o_SR_DevolucionCabeceraBN->getObservaciones() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getFechaInicioAlq() ) )
        {
            $this->setFechaInicioAlq( $o_SR_DevolucionCabeceraBN->getFechaInicioAlq() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getFechaDevolucion() ) )
        {
            $this->setFechaDevolucion( $o_SR_DevolucionCabeceraBN->getFechaDevolucion() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getEstado() ) )
        {
            $this->setEstado( $o_SR_DevolucionCabeceraBN->getEstado() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getEstadoCorte() ) )
        {
            $this->setEstadoCorte( $o_SR_DevolucionCabeceraBN->getEstadoCorte() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_SR_DevolucionCabeceraBN->getFechaCreacion() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_SR_DevolucionCabeceraBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_SR_DevolucionCabeceraBN->getFechaModificacion() );
        }
        if ( !is_null( $o_SR_DevolucionCabeceraBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_SR_DevolucionCabeceraBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SR_DevolucionCabeceraFN = new SR_DevolucionCabeceraFN();
        $o_SR_DevolucionCabeceraBN = $o_SR_DevolucionCabeceraFN->selectByPk( $this->getDevolucionCabId() );
        if ( is_null( $o_SR_DevolucionCabeceraBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SR_DevolucionCabecera ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getDevolucionCabId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DevolucionCabId";
                $s_SQLQuery2 .= $s_Separator."".$this->getDevolucionCabId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdProyecto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdProyecto";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdProyecto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOrdenId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."OrdenId";
                $s_SQLQuery2 .= $s_Separator."".$this->getOrdenId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getParentId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ParentId";
                $s_SQLQuery2 .= $s_Separator."".$this->getParentId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Tipo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTransGuiaSerie() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TransGuiaSerie";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTransGuiaSerie()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTransGuiaNumero() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TransGuiaNumero";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTransGuiaNumero()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getObraGuiaSerie() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ObraGuiaSerie";
                $s_SQLQuery2 .= $s_Separator."'".$this->getObraGuiaSerie()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getObraGuiaNumero() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ObraGuiaNumero";
                $s_SQLQuery2 .= $s_Separator."'".$this->getObraGuiaNumero()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getObservaciones() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Observaciones";
                $s_SQLQuery2 .= $s_Separator."'".$this->getObservaciones()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaInicioAlq() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaInicioAlq";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaInicioAlq()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaDevolucion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaDevolucion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaDevolucion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoCorte() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EstadoCorte";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstadoCorte()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SR_DevolucionCabecera SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdProyecto() ) )
            {
                $s_SQLQuery .= $s_Separator."IdProyecto = ".$this->getIdProyecto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOrdenId() ) )
            {
                $s_SQLQuery .= $s_Separator."OrdenId = ".$this->getOrdenId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getParentId() ) )
            {
                $s_SQLQuery .= $s_Separator."ParentId = ".$this->getParentId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipo() ) )
            {
                $s_SQLQuery .= $s_Separator."Tipo = '".$this->getTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTransGuiaSerie() ) )
            {
                $s_SQLQuery .= $s_Separator."TransGuiaSerie = '".$this->getTransGuiaSerie()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTransGuiaNumero() ) )
            {
                $s_SQLQuery .= $s_Separator."TransGuiaNumero = '".$this->getTransGuiaNumero()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getObraGuiaSerie() ) )
            {
                $s_SQLQuery .= $s_Separator."ObraGuiaSerie = '".$this->getObraGuiaSerie()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getObraGuiaNumero() ) )
            {
                $s_SQLQuery .= $s_Separator."ObraGuiaNumero = '".$this->getObraGuiaNumero()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getObservaciones() ) )
            {
                $s_SQLQuery .= $s_Separator."Observaciones = '".$this->getObservaciones()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaInicioAlq() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaInicioAlq = '".$this->getFechaInicioAlq()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaDevolucion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaDevolucion = '".$this->getFechaDevolucion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoCorte() ) )
            {
                $s_SQLQuery .= $s_Separator."EstadoCorte = '".$this->getEstadoCorte()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  DevolucionCabId = ".$this->getDevolucionCabId().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SR_DevolucionCabecera WHERE  DevolucionCabId = ".$this->getDevolucionCabId().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>